<template>
  <div>
    <RouterView v-if="moduleIsReady" />
    <b-row v-else align-h="center" class="my-4">
      <b-spinner variant="primary" />
    </b-row>
  </div>
</template>

<script lang="ts">
import { ResourceI18nMessages } from "./i18n";

// import the store for current module
import useResourceStore from "./store";
import useProjectStore from "@/modules/project/store";

import type { VisitedResourceObject } from "./types";
import i18n from "@/plugins/vue-i18n";
import { cloneDeep } from "lodash";
import type { RouteLocationNormalized } from "vue-router";
import type {
  ProjectDto,
  ResourceTypeInformationDto,
} from "@coscine/api-client/dist/types/Coscine.Api";
import useNotificationStore from "@/store/notification";

export default defineComponent({
  async beforeRouteUpdate(to, from, next) {
    await this.apiFetch(to);
    next();
  },
  setup() {
    const resourceStore = useResourceStore();
    const projectStore = useProjectStore();
    const notificationStore = useNotificationStore();

    return { resourceStore, projectStore, notificationStore };
  },

  data() {
    return {
      // Don't allow page load before resource is fully loaded
      loadingInitData: true,
    };
  },

  computed: {
    project(): ProjectDto | null {
      return this.projectStore.currentProject;
    },
    inMaintenanceMode(): boolean {
      return this.resource?.maintenanceMode === true;
    },
    resource(): VisitedResourceObject | null {
      return this.resourceStore.currentResource;
    },
    resourceTypeInformation(): ResourceTypeInformationDto | undefined {
      return this.resourceStore.enabledResourceTypes?.find(
        (resourceType) => resourceType.id === this.resource?.type?.id
      );
    },
    moduleIsReady(): boolean {
      if (
        this.projectStore.currentProject &&
        this.projectStore.currentUserRole &&
        this.resourceStore.currentResource &&
        !this.resourceStore.currentResource.maintenanceMode && // Resource is not in maintenance mode
        !this.loadingInitData
      ) {
        return true;
      }
      return false;
    },
  },

  watch: {
    async resourceTypeInformation() {
      this.setI18n();
    },
    async inMaintenanceMode() {
      // Redirect to project page
      if (this.inMaintenanceMode) {
        this.redirectAway();
      }
    },
  },

  mounted() {
    this.initialize();
  },

  beforeDestroy() {
    // Set current resource ID to null
    this.resourceStore.currentId = null;
  },

  methods: {
    async initialize() {
      this.loadingInitData = true;
      await this.apiFetch(this.$router.currentRoute.value);
      this.loadingInitData = false;
    },

    redirectAway() {
      this.$router.replace({
        name: "project-page",
        params: { slug: this.project?.slug },
      });

      // Resource is in maintenance mode, show notification
      this.notificationStore.postNotification({
        variant: "info",
        title: this.$t("page.module.redirection.maintenance.title"),
        body: this.$t("page.module.redirection.maintenance.body"),
      });
    },

    async apiFetch(route: RouteLocationNormalized) {
      if (this.project?.id) {
        // Resource may be unset (e.g. when entering from a direct link)
        await this.resourceStore.retrieveUnsetResource(
          this.project.id,
          this.resource,
          route
        );
        if (this.resource) {
          if (!this.resourceStore.currentFullApplicationProfile) {
            this.resourceStore.retrieveApplicationProfile(this.resource);
          }
        }
        this.setI18n();
      }
    },

    setI18n() {
      i18n.global.mergeLocaleMessage("de", cloneDeep(ResourceI18nMessages.de));
      i18n.global.mergeLocaleMessage("en", cloneDeep(ResourceI18nMessages.en));
      if (
        this.resourceTypeInformation &&
        this.resourceTypeInformation.specificType
      ) {
        if (ResourceI18nMessages.de.resourceType) {
          const germanResourceTypeMessageObject =
            ResourceI18nMessages.de.resourceType;
          if (
            germanResourceTypeMessageObject[
              this.resourceTypeInformation
                .specificType as keyof typeof germanResourceTypeMessageObject
            ]
          ) {
            const resourceTypeDefinition =
              germanResourceTypeMessageObject[
                this.resourceTypeInformation
                  .specificType as keyof typeof germanResourceTypeMessageObject
              ];
            i18n.global.mergeLocaleMessage(
              "de",
              cloneDeep(resourceTypeDefinition)
            );
          }
        }
        if (ResourceI18nMessages.en.resourceType) {
          const englishResourceTypeMessageObject =
            ResourceI18nMessages.en.resourceType;
          if (
            englishResourceTypeMessageObject[
              this.resourceTypeInformation
                .specificType as keyof typeof englishResourceTypeMessageObject
            ]
          ) {
            const resourceTypeDefinition =
              englishResourceTypeMessageObject[
                this.resourceTypeInformation
                  .specificType as keyof typeof englishResourceTypeMessageObject
              ];
            i18n.global.mergeLocaleMessage(
              "en",
              cloneDeep(resourceTypeDefinition)
            );
          }
        }
      }
    },
  },
});
</script>

<style></style>
